var isRunning = 0;
var wsIsConnected = 0;
var output;


var f32array = [];
var f32temp = [];
var fft_size = 1024*4;
var rate = 10;
var freq = 100;
var gain = 30;

// Button: make
function make_onclick_func()
{

    if ( wsIsConnected == 0) {
	initWebSocketEvents();
	wsIsConnected = 1;
	document.getElementById("id_srvr1").style="border: thin green solid"
	document.getElementById("button1").value="make"
    }
    else {
	var addr_type = document.getElementById("id_sdr1").value;
	var mycmd= "make " + addr_type;
	//var mycmd= "make type=x300";
	console.log( mycmd );  // make addr0=192.168.10.2 or type=x300
	doSend(mycmd);
	wsIsConnected = 2;
	document.getElementById("id_sdr1").style="border: thin green solid"
	document.getElementById("button1").value="done"
	document.getElementById("button1").disabled = true;
    }
}

// Button: submit
function button2_onclick_func()
{
    // TODO -  find number of channels and loop over them
    var mycmd;
    var ch = 0;
    rate = document.getElementById("rate1").value;
    freq = document.getElementById("freq1").value;
    gain = document.getElementById("gain1").value;

    mycmd= "rxconfig " + ch + " " + freq + " " + rate + " " + gain;
    doSend(mycmd);
    
    ch = 1;
    mycmd = "rxconfig " + ch + " " + freq + " " + rate + " " + gain;
    doSend(mycmd);

    ch = 2;
    mycmd = "rxconfig " + ch + " " + freq + " " + rate + " " + gain;
    doSend(mycmd);

    ch = 3;
    mycmd = "rxconfig " + ch + " " + freq + " " + rate + " " + gain;
    doSend(mycmd);

    
    document.getElementById("rate1").style="border: thin green solid"
    document.getElementById("freq1").style="border: thin green solid"
    document.getElementById("gain1").style="border: thin green solid"

    document.getElementById("rate1").disabled = true;

}



// Button: running / halted
function btn2_onclick_func()
{
    var tmp_str = document.getElementById("btn2").value
    if (tmp_str == "Halted") {

	// Set new value of button
	document.getElementById("btn2").value = "Running";
	doSend("rxstream start_fft " + fft_size);
	isRunning = 1;
    }
    else if (tmp_str == "Running") {

	// Set new value of button
	document.getElementById("btn2").value = "Halted";
	doSend("rxstream stop_fft");
	isRunning = 0;
    }
}




function init()
{
    output = document.getElementById("output");
    //initWebSocketEvents();
}

function initWebSocketEvents()
{
    var node_url = document.getElementById("id_srvr1").value;
    var wsUri = "ws://"+ node_url;

    websocket = new WebSocket(wsUri);
    websocket.binaryType = "arraybuffer";

    websocket.onopen = function(evt) { onOpen(evt) };
    websocket.onclose = function(evt) { onClose(evt) };
    websocket.onmessage = function(evt) { onMessage(evt) };
    websocket.onerror = function(evt) { onError(evt) };
}

function onOpen(evt)
{
    writeToScreen("CONNECTED");
    //doSend("make addr0=10.10.23.1");
    //doSend("rxconfig 0 2400e6 25e6 30");
    //doSend("rxconfig 1 2400e6 25e6 30");

    //doSend("rxstream start_fft " + fft_size);
    //document.getElementById("rate1").disabled = false;
}

function onClose(evt)
{
    writeToScreen("DISCONNECTED");

    // reset input boxes and buttons
    document.getElementById("button1").disabled = false;
    document.getElementById("button1").value="connect"
    document.getElementById("id_srvr1").style="border: thin red solid"
    document.getElementById("id_sdr1").style="border: thin red solid"
    document.getElementById("rate1").style="border: thin red solid"
    document.getElementById("freq1").style="border: thin red solid"
    document.getElementById("gain1").style="border: thin red solid"
    document.getElementById("btn2").value = "Halted";

    wsIsConnected = 0;
}

function onMessage(evt)
{
    if(evt.data instanceof ArrayBuffer) {
        //writeToScreen('<span style="color: green;">RESPONSE: ' + evt.data+'</span>');

	// get 8 bytes header out of the ArrayBuffer and cast as ui32 array
        var FIRST_IDX = 0;
        var LAST_IDX = 2;
        var ui32array = new Uint32Array(evt.data.slice(FIRST_IDX * 4, LAST_IDX *4));
	var type = ui32array[0];
	var nbytes = ui32array[1];

	//console.log("type = " + ui32array[0]   );  // type
        //console.log("nbytes = " + ui32array[1] );  // number of bytes to follow

	switch(type) {
	case 0x1:
            //console.log("fft_size = " + fft_size );  // number of bytes to follow
	    console.assert((nbytes/4) == fft_size, "ERROR: message payload size mismatch");
            FIRST_IDX = 2;
            LAST_IDX = (2 + fft_size);

            f32array = new Float32Array(evt.data.slice(FIRST_IDX * 4 , LAST_IDX * 4) );
            //console.log("array length = " + f32array.length);

            compute_axis(); // f32temp
	    break;
	case 0x2:
	    
	    break;
	default:
	    break;
	}
    }
    else {
	writeToScreen('<span style="color: blue;">RESPONSE: ' + evt.data+'</span>');

    }
    //websocket.close();
}

function onError(evt)
{
    writeToScreen('<span style="color: red;">ERROR:</span> ' + evt.data);
}

function doSend(message)
{
    //writeToScreen("SENT: " + message);
    websocket.send(message);
}

function writeToScreen(message)
{
    var pre = document.createElement("p");
    pre.style.wordWrap = "break-word";
    pre.innerHTML = message;
    output.appendChild(pre);
}

window.addEventListener("load", init, false);



var tmr_interval_ms = 100;
var my_tmr = setInterval(tmr_handler, tmr_interval_ms);
function tmr_handler()
{
    if ((wsIsConnected == 0) || (wsIsConnected == 1))  { return; }
    if (isRunning == 0) { return; }

    doSend("rxsig_fftmag"); // rxsig_fftmag is a dummy command.
                            // still needs to be parse by websock server.
}








var n = fft_size;
var x_ax = [], y_ax = [];

for (i = 0; i < n; i++) {
    x_ax[i] = i;
    y_ax[i] = i/n; //Math.random() * 2 - 1;
}


Plotly.plot('graph',
            [{x: x_ax,
	      y: y_ax,
	      mode: 'lines',
	     }
	    ],
	    {   yaxis: { range: [-0.1, 1.0]},
                //xaxis: { range: [100, 200 ]},
		title: "--Spectrum Display -- Center Freq (MHz)--"
	    }
	   )

function compute_axis () {
    var step = rate / fft_size;
    for (i = 0; i < fft_size; i++) {
	x_ax[i] = Number( (freq - rate/2 + step*i)/1e6 );
    }
}

function update () {
    Plotly.animate('graph',
		   {
		       data: [
			   {x: x_ax,
			    y: f32array, 
			    mode: 'lines',
			    marker:   { color: 'blue', size: 1 }
			   },

			   //               {x: x_ax, 
			   //                y: f32temp, 
			   //                mode: 'markers',
			   //                marker: { color: 'red', size: 3 },
			   //               }

		       ]

		   },
		   {
		       transition: {
			   duration: 50,
		       },
		       frame: {
			   duration: 0,
			   redraw: true, // to update the x-axis range
		       }
		   }



		   
		  );
    
    requestAnimationFrame(update);
}

requestAnimationFrame(update);
